library(data.table)
library(dplyr)

# load burden
filelist <- c("gw.maf00001.ptvsum.hba_brain", "gw.maf00001.missensesum_MPC1_3.hba_brain", "gw.maf00001.missensesum_MPC1_2.hba_brain", "gw.maf00001.missensesum_MPC1_0.hba_brain", "gw.maf00001.synonymoussum.hba_brain", "gw.maf00001.ptvsum.hba_other", "gw.maf00001.missensesum_MPC1_3.hba_other", "gw.maf00001.missensesum_MPC1_2.hba_other", "gw.maf00001.missensesum_MPC1_0.hba_other", "gw.maf00001.synonymoussum.hba_other", "gw.maf00001.ptvsum.hba_nospe", "gw.maf00001.missensesum_MPC1_3.hba_nospe", "gw.maf00001.missensesum_MPC1_2.hba_nospe", "gw.maf00001.missensesum_MPC1_0.hba_nospe", "gw.maf00001.synonymoussum.hba_nospe", "pLI_intol.maf00001.ptvsum.hba_brain", "pLI_intol.maf00001.missensesum_MPC1_3.hba_brain", "pLI_intol.maf00001.missensesum_MPC1_2.hba_brain", "pLI_intol.maf00001.missensesum_MPC1_0.hba_brain", "pLI_intol.maf00001.synonymoussum.hba_brain", "pLI_intol.maf00001.ptvsum.hba_other", "pLI_intol.maf00001.missensesum_MPC1_3.hba_other", "pLI_intol.maf00001.missensesum_MPC1_2.hba_other", "pLI_intol.maf00001.missensesum_MPC1_0.hba_other", "pLI_intol.maf00001.synonymoussum.hba_other", "pLI_intol.maf00001.ptvsum.hba_nospe", "pLI_intol.maf00001.missensesum_MPC1_3.hba_nospe", "pLI_intol.maf00001.missensesum_MPC1_2.hba_nospe", "pLI_intol.maf00001.missensesum_MPC1_0.hba_nospe", "pLI_intol.maf00001.synonymoussum.hba_nospe", "pLI_tol.maf00001.ptvsum.hba_brain", "pLI_tol.maf00001.missensesum_MPC1_3.hba_brain", "pLI_tol.maf00001.missensesum_MPC1_2.hba_brain", "pLI_tol.maf00001.missensesum_MPC1_0.hba_brain", "pLI_tol.maf00001.synonymoussum.hba_brain", "pLI_tol.maf00001.ptvsum.hba_other", "pLI_tol.maf00001.missensesum_MPC1_3.hba_other", "pLI_tol.maf00001.missensesum_MPC1_2.hba_other", "pLI_tol.maf00001.missensesum_MPC1_0.hba_other", "pLI_tol.maf00001.synonymoussum.hba_other", "pLI_tol.maf00001.ptvsum.hba_nospe", "pLI_tol.maf00001.missensesum_MPC1_3.hba_nospe", "pLI_tol.maf00001.missensesum_MPC1_2.hba_nospe", "pLI_tol.maf00001.missensesum_MPC1_0.hba_nospe", "pLI_tol.maf00001.synonymoussum.hba_nospe") 

burden_raw <- fread(paste0("/MYPATH/ukbb.",filelist[1],".txt"))
for (i in 2:length(filelist)){
tmpdat <- fread(paste0("/MYPATH/ukbb.",filelist[i],".txt"))
burden_raw <- inner_join(burden_raw,tmpdat,by="eid_sample")
}
colnames(burden_raw)[2:(length(filelist)+1)] <- filelist

colnames(burden_raw)[1] <- "IID"

burden_raw$gw.maf00001.missensesum_MPC_ALL.hba_nospe  <- burden_raw$gw.maf00001.missensesum_MPC1_2.hba_nospe + burden_raw$gw.maf00001.missensesum_MPC1_3.hba_nospe + burden_raw$gw.maf00001.missensesum_MPC1_0.hba_nospe 

burden_raw$gw.maf00001.missensesum_MPC_ALL.hba_brain <- burden_raw$gw.maf00001.missensesum_MPC1_3.hba_brain + burden_raw$gw.maf00001.missensesum_MPC1_0.hba_brain + burden_raw$gw.maf00001.missensesum_MPC1_2.hba_brain 

burden_raw$gw.maf00001.missensesum_MPC_ALL.hba_other <- burden_raw$gw.maf00001.missensesum_MPC1_3.hba_other + burden_raw$gw.maf00001.missensesum_MPC1_0.hba_other + burden_raw$gw.maf00001.missensesum_MPC1_2.hba_other 

# load pheno
pheno_unrel <- fread("/MYPATH/MYFILE.EUR.unrel.txt")

# make data for analysis
dat_raw <- inner_join(burden_raw, pheno_unrel, by="IID")
dat_raw <- as.data.frame(dat_raw)

# analysis
phenolist <- c("edu_baseline","rt_baseline","fiall_baseline")
burdenlist <- c("gw.maf00001.ptvsum.hba_brain", "gw.maf00001.missensesum_MPC1_3.hba_brain", "gw.maf00001.missensesum_MPC1_2.hba_brain", "gw.maf00001.missensesum_MPC1_0.hba_brain", "gw.maf00001.synonymoussum.hba_brain", "gw.maf00001.ptvsum.hba_other", "gw.maf00001.missensesum_MPC1_3.hba_other", "gw.maf00001.missensesum_MPC1_2.hba_other", "gw.maf00001.missensesum_MPC1_0.hba_other", "gw.maf00001.synonymoussum.hba_other", "gw.maf00001.ptvsum.hba_nospe", "gw.maf00001.missensesum_MPC1_3.hba_nospe", "gw.maf00001.missensesum_MPC1_2.hba_nospe", "gw.maf00001.missensesum_MPC1_0.hba_nospe", "gw.maf00001.synonymoussum.hba_nospe")

output_raw <- c()
for (i in 1:length(phenolist)){
	for (k in 1:length(burdenlist)){

	pheno = phenolist[i]
	burden = burdenlist[k]

	pheno_tmp <- scale(dat_raw[,paste0(pheno,"_irnt")])
	formula <- paste0(paste0("pheno_tmp~",burden,"+sex+",pheno,"_age_mean0+",pheno,"_age_mean02+",pheno,"_age_mean0_sex+",pheno,"_age_mean02_sex+"),paste0("PC",seq(1,20,1),collapse="+"),"+assess_center10003+assess_center11001+assess_center11002+assess_center11003+assess_center11004+assess_center11005+assess_center11006+assess_center11007+assess_center11008+assess_center11009+assess_center11011+assess_center11012+assess_center11013+assess_center11014+assess_center11016+assess_center11017+assess_center11018+assess_center11020+assess_center11021+assess_center11022+assess_center11023")
	glm_fit_tmp <- summary(glm(formula,data=dat_raw,family="gaussian"))
	output_raw <- rbind(output_raw, c(pheno, burden, glm_fit_tmp$coef[2,c(1,2,4)], (glm_fit_tmp$df.null+1)))
}
}

colnames(output_raw) <- c("Phenotype","Burden","BETA","SE","P","N")
output_raw <- as.data.frame(output_raw)
output_raw$Phenotype <- as.character(output_raw$Phenotype)
output_raw$Burden <- as.character(output_raw$Burden)
output_raw$BETA <- as.numeric(as.character(output_raw$BETA))
output_raw$SE <- as.numeric(as.character(output_raw$SE))
output_raw$P <- as.numeric(as.character(output_raw$P))
output_raw$N <- as.numeric(as.character(output_raw$N))
output_raw$model <- rep(2,length(output_raw[,1]))

write.table(output_raw,"ukbb.burden.HBA.association.summary.txt",col.names=TRUE,row.names=FALSE,quote=FALSE,sep=" ")
