args     <- commandArgs(TRUE)
gwascode <- as.character(args[1])

tmpdata <- read.table(paste0("./",gwascode,".chr1.sscore"),stringsAsFactors=FALSE)

outputdata <- data.frame(matrix(ncol = 45, nrow = length(tmpdata[,1])))
colnames(outputdata) <- c("IID", "SCORE1_SUM_CHR1", "SCORE1_SUM_CHR2", "SCORE1_SUM_CHR3", "SCORE1_SUM_CHR4", "SCORE1_SUM_CHR5", "SCORE1_SUM_CHR6", "SCORE1_SUM_CHR7", "SCORE1_SUM_CHR8", "SCORE1_SUM_CHR9", "SCORE1_SUM_CHR10", "SCORE1_SUM_CHR11", "SCORE1_SUM_CHR12", "SCORE1_SUM_CHR13", "SCORE1_SUM_CHR14", "SCORE1_SUM_CHR15", "SCORE1_SUM_CHR16", "SCORE1_SUM_CHR17", "SCORE1_SUM_CHR18", "SCORE1_SUM_CHR19", "SCORE1_SUM_CHR20", "SCORE1_SUM_CHR21", "SCORE1_SUM_CHR22", "ALLELE_CT_CHR1", "ALLELE_CT_CHR2", "ALLELE_CT_CHR3", "ALLELE_CT_CHR4", "ALLELE_CT_CHR5", "ALLELE_CT_CHR6", "ALLELE_CT_CHR7", "ALLELE_CT_CHR8", "ALLELE_CT_CHR9", "ALLELE_CT_CHR10", "ALLELE_CT_CHR11", "ALLELE_CT_CHR12", "ALLELE_CT_CHR13", "ALLELE_CT_CHR14", "ALLELE_CT_CHR15", "ALLELE_CT_CHR16", "ALLELE_CT_CHR17", "ALLELE_CT_CHR18", "ALLELE_CT_CHR19", "ALLELE_CT_CHR20", "ALLELE_CT_CHR21", "ALLELE_CT_CHR22")

outputdata$IID <- tmpdata$V1
outputdata$SCORE1_SUM_CHR1 <- tmpdata$V5
outputdata$ALLELE_CT_CHR1 <- tmpdata$V2

for (i in 2:22){
tmpdata <- read.table(paste0("./",gwascode,".chr",i,".sscore"),stringsAsFactors=FALSE)
outputdata[,paste0("SCORE1_SUM_CHR",i)] <- tmpdata[,5]
outputdata[,paste0("ALLELE_CT_CHR",i)] <- tmpdata[,2]
}

outputdata$TOTALSCORE_SUM <- rowSums(outputdata[,c("SCORE1_SUM_CHR1", "SCORE1_SUM_CHR2", "SCORE1_SUM_CHR3", "SCORE1_SUM_CHR4", "SCORE1_SUM_CHR5", "SCORE1_SUM_CHR6", "SCORE1_SUM_CHR7", "SCORE1_SUM_CHR8", "SCORE1_SUM_CHR9", "SCORE1_SUM_CHR10", "SCORE1_SUM_CHR11", "SCORE1_SUM_CHR12", "SCORE1_SUM_CHR13", "SCORE1_SUM_CHR14", "SCORE1_SUM_CHR15", "SCORE1_SUM_CHR16", "SCORE1_SUM_CHR17", "SCORE1_SUM_CHR18", "SCORE1_SUM_CHR19", "SCORE1_SUM_CHR20", "SCORE1_SUM_CHR21", "SCORE1_SUM_CHR22")], na.rm=FALSE)
outputdata$TOTALALLLELCT <- rowSums(outputdata[,c("ALLELE_CT_CHR1", "ALLELE_CT_CHR2", "ALLELE_CT_CHR3", "ALLELE_CT_CHR4", "ALLELE_CT_CHR5", "ALLELE_CT_CHR6", "ALLELE_CT_CHR7", "ALLELE_CT_CHR8", "ALLELE_CT_CHR9", "ALLELE_CT_CHR10", "ALLELE_CT_CHR11", "ALLELE_CT_CHR12", "ALLELE_CT_CHR13", "ALLELE_CT_CHR14", "ALLELE_CT_CHR15", "ALLELE_CT_CHR16", "ALLELE_CT_CHR17", "ALLELE_CT_CHR18", "ALLELE_CT_CHR19", "ALLELE_CT_CHR20", "ALLELE_CT_CHR21", "ALLELE_CT_CHR22")], na.rm=FALSE)
outputdata$TOTALSCORE_AVG<-outputdata$TOTALSCORE_SUM/outputdata$TOTALALLLELCT

write.table(outputdata[,c("IID", "TOTALSCORE_AVG", "TOTALSCORE_SUM", "TOTALALLLELCT")],paste0("./",gwascode,".totalscore"),quote=FALSE,row.names=FALSE,col.names=TRUE,sep=" ")
